// MythMatch Version 1
// Send Comments/Improvements/Faults to TwentyOneScore@BeerInHand.com
/*
420 Resources and 42 Favor granted every 60 seconds make MythMatch play like a Deathmatch
game but with a slower start. Free Flowing Favor makes Myth Unit filled armies possible.
To counter this, Heroes get faster as the game progresses.

Every 60 seconds of game time you'll be granted 420 resources and 42 favor. This simulates
a small economic engine to start the game moving along quickly, but does not replace the
need to build a stronger one for the Endgame. The generous Favor of the Gods allows you to
quickly build up a myth unit army. To counter this, every 120 seconds of game time Heroes get
20% faster, and to keep you economy booming, your Villagers gather 10% faster. Each Player
starts in a corner of the map on a mountain stronghold with a moat that is easily defendable.
There are 5 skins for this map - winter, spring, summer, fall, and Hades, randomly selected
at startup. Relics are placed 2 per player around the map. Depending on the skin selected,
you'll have an invincible bird scout that randomly flies around the map giving you it's LOS.
If the High Gods are smiling, you'll get a Harpy that you can control by pressing comma, and
when they are really High, you'll get a Flying Purple Hippo!
*/
// GLOBALS ***************************************************
int MapSkin = 1;
int LandOrSea = 1;
float SeaLevel = -6;
int WaterOnMap = 0;

int nearShoreLineVeryShort=0;

const int cGoldAmtTiny=1500;
const int cGoldAmtSmall=3000;
const int cGoldAmtLarge=6000;

// DEFINE SOME DISTANCE CONSTANTS
const int cVeryShort=3;
const int cShort=10;
const int cMedium=20;
const int cLong=40;
const int cVeryLong=80;

float iifF(bool cond=true, float val1=0, float val2=0) {
   if (cond==true) return(val1);
   else return(val2);
}

float min(float val1=0, float val2=0) {
   if (val1>val2) return (val2+0.0);
   else return(val1+0.0);
}
float max(float val1=0, float val2=0) {
   if (val1<val2) return (val2+0.0);
   else return(val1+0.0);
}

/* MATH FUNCTIONS  ************************************/
float sin(float Angle=0) {
   float MyAngle=Angle % 360; //iifF(Angle>360,Angle-360,Angle);
   if (MyAngle<=    0) return(.00000000000000);
   else if (MyAngle<=    5) return(.08715574274766);
   else if (MyAngle<=    10) return(.17364817766693);
   else if (MyAngle<=    15) return(.25881904510252);
   else if (MyAngle<=    20) return(.34202014332567);
   else if (MyAngle<=    25) return(.42261826174070);
   else if (MyAngle<=    30) return(.50000000000000);
   else if (MyAngle<=    35) return(.57357643635105);
   else if (MyAngle<=    40) return(.64278760968654);
   else if (MyAngle<=    45) return(.70710678118655);
   else if (MyAngle<=    50) return(.76604444311898);
   else if (MyAngle<=    55) return(.81915204428899);
   else if (MyAngle<=    60) return(.86602540378444);
   else if (MyAngle<=    65) return(.90630778703665);
   else if (MyAngle<=    70) return(.93969262078591);
   else if (MyAngle<=    75) return(.96592582628907);
   else if (MyAngle<=    80) return(.98480775301221);
   else if (MyAngle<=    85) return(.99619469809175);
   else if (MyAngle<=    90) return(1.00000000000000);
   else if (MyAngle<=    95) return(.99619469809175);
   else if (MyAngle<=    100) return(.98480775301221);
   else if (MyAngle<=    105) return(.96592582628907);
   else if (MyAngle<=    110) return(.93969262078591);
   else if (MyAngle<=    115) return(.90630778703665);
   else if (MyAngle<=    120) return(.86602540378444);
   else if (MyAngle<=    125) return(.81915204428899);
   else if (MyAngle<=    130) return(.76604444311898);
   else if (MyAngle<=    135) return(.70710678118655);
   else if (MyAngle<=    140) return(.64278760968654);
   else if (MyAngle<=    145) return(.57357643635105);
   else if (MyAngle<=    150) return(.50000000000000);
   else if (MyAngle<=    155) return(.42261826174070);
   else if (MyAngle<=    160) return(.34202014332567);
   else if (MyAngle<=    165) return(.25881904510252);
   else if (MyAngle<=    170) return(.17364817766693);
   else if (MyAngle<=    175) return(.08715574274766);
   else if (MyAngle<=    180) return(.00000000000000);
   else if (MyAngle<=    185) return(-.08715574274766);
   else if (MyAngle<=    190) return(-.17364817766693);
   else if (MyAngle<=    195) return(-.25881904510252);
   else if (MyAngle<=    200) return(-.34202014332567);
   else if (MyAngle<=    205) return(-.42261826174070);
   else if (MyAngle<=    210) return(-.50000000000000);
   else if (MyAngle<=    215) return(-.57357643635105);
   else if (MyAngle<=    220) return(-.64278760968654);
   else if (MyAngle<=    225) return(-.70710678118655);
   else if (MyAngle<=    230) return(-.76604444311898);
   else if (MyAngle<=    235) return(-.81915204428899);
   else if (MyAngle<=    240) return(-.86602540378444);
   else if (MyAngle<=    245) return(-.90630778703665);
   else if (MyAngle<=    250) return(-.93969262078591);
   else if (MyAngle<=    255) return(-.96592582628907);
   else if (MyAngle<=    260) return(-.98480775301221);
   else if (MyAngle<=    265) return(-.99619469809175);
   else if (MyAngle<=    270) return(-1.00000000000000);
   else if (MyAngle<=    275) return(-.99619469809175);
   else if (MyAngle<=    280) return(-.98480775301221);
   else if (MyAngle<=    285) return(-.96592582628907);
   else if (MyAngle<=    290) return(-.93969262078591);
   else if (MyAngle<=    295) return(-.90630778703665);
   else if (MyAngle<=    300) return(-.86602540378444);
   else if (MyAngle<=    305) return(-.81915204428899);
   else if (MyAngle<=    310) return(-.76604444311898);
   else if (MyAngle<=    315) return(-.70710678118655);
   else if (MyAngle<=    320) return(-.64278760968654);
   else if (MyAngle<=    325) return(-.57357643635105);
   else if (MyAngle<=    330) return(-.50000000000000);
   else if (MyAngle<=    335) return(-.42261826174070);
   else if (MyAngle<=    340) return(-.34202014332567);
   else if (MyAngle<=    345) return(-.25881904510252);
   else if (MyAngle<=    350) return(-.17364817766693);
   else if (MyAngle<=    355) return(-.08715574274766);
   else if (MyAngle<=    360) return(.00000000000000);
}
float cos(float Angle=0) {
   float MyAngle=iifF(Angle>360,Angle-360,Angle);
   if (MyAngle<=    0) return(1.00000000000000);
   else if (MyAngle<=    5) return(.99619469809175);
   else if (MyAngle<=    10) return(.98480775301221);
   else if (MyAngle<=    15) return(.96592582628907);
   else if (MyAngle<=    20) return(.93969262078591);
   else if (MyAngle<=    25) return(.90630778703665);
   else if (MyAngle<=    30) return(.86602540378444);
   else if (MyAngle<=    35) return(.81915204428899);
   else if (MyAngle<=    40) return(.76604444311898);
   else if (MyAngle<=    45) return(.70710678118655);
   else if (MyAngle<=    50) return(.64278760968654);
   else if (MyAngle<=    55) return(.57357643635105);
   else if (MyAngle<=    60) return(.50000000000000);
   else if (MyAngle<=    65) return(.42261826174070);
   else if (MyAngle<=    70) return(.34202014332567);
   else if (MyAngle<=    75) return(.25881904510252);
   else if (MyAngle<=    80) return(.17364817766693);
   else if (MyAngle<=    85) return(.08715574274766);
   else if (MyAngle<=    90) return(.00000000000000);
   else if (MyAngle<=    95) return(-.08715574274766);
   else if (MyAngle<=    100) return(-.17364817766693);
   else if (MyAngle<=    105) return(-.25881904510252);
   else if (MyAngle<=    110) return(-.34202014332567);
   else if (MyAngle<=    115) return(-.42261826174070);
   else if (MyAngle<=    120) return(-.50000000000000);
   else if (MyAngle<=    125) return(-.57357643635105);
   else if (MyAngle<=    130) return(-.64278760968654);
   else if (MyAngle<=    135) return(-.70710678118655);
   else if (MyAngle<=    140) return(-.76604444311898);
   else if (MyAngle<=    145) return(-.81915204428899);
   else if (MyAngle<=    150) return(-.86602540378444);
   else if (MyAngle<=    155) return(-.90630778703665);
   else if (MyAngle<=    160) return(-.93969262078591);
   else if (MyAngle<=    165) return(-.96592582628907);
   else if (MyAngle<=    170) return(-.98480775301221);
   else if (MyAngle<=    175) return(-.99619469809175);
   else if (MyAngle<=    180) return(-1.00000000000000);
   else if (MyAngle<=    185) return(-.99619469809175);
   else if (MyAngle<=    190) return(-.98480775301221);
   else if (MyAngle<=    195) return(-.96592582628907);
   else if (MyAngle<=    200) return(-.93969262078591);
   else if (MyAngle<=    205) return(-.90630778703665);
   else if (MyAngle<=    210) return(-.86602540378444);
   else if (MyAngle<=    215) return(-.81915204428899);
   else if (MyAngle<=    220) return(-.76604444311898);
   else if (MyAngle<=    225) return(-.70710678118655);
   else if (MyAngle<=    230) return(-.64278760968654);
   else if (MyAngle<=    235) return(-.57357643635105);
   else if (MyAngle<=    240) return(-.50000000000000);
   else if (MyAngle<=    245) return(-.42261826174070);
   else if (MyAngle<=    250) return(-.34202014332567);
   else if (MyAngle<=    255) return(-.25881904510252);
   else if (MyAngle<=    260) return(-.17364817766693);
   else if (MyAngle<=    265) return(-.08715574274766);
   else if (MyAngle<=    270) return(.00000000000000);
   else if (MyAngle<=    275) return(.08715574274766);
   else if (MyAngle<=    280) return(.17364817766693);
   else if (MyAngle<=    285) return(.25881904510252);
   else if (MyAngle<=    290) return(.34202014332567);
   else if (MyAngle<=    295) return(.42261826174070);
   else if (MyAngle<=    300) return(.50000000000000);
   else if (MyAngle<=    305) return(.57357643635105);
   else if (MyAngle<=    310) return(.64278760968654);
   else if (MyAngle<=    315) return(.70710678118655);
   else if (MyAngle<=    320) return(.76604444311898);
   else if (MyAngle<=    325) return(.81915204428899);
   else if (MyAngle<=    330) return(.86602540378444);
   else if (MyAngle<=    335) return(.90630778703665);
   else if (MyAngle<=    340) return(.93969262078591);
   else if (MyAngle<=    345) return(.96592582628907);
   else if (MyAngle<=    350) return(.98480775301221);
   else if (MyAngle<=    355) return(.99619469809175);
   else if (MyAngle<=    360) return(1.00000000000000);
}
float GetXPointOnCircle(float Angle=0, float Radius=0, float AtX=.5) {
   float MyX = (Radius * cos(Angle) + AtX); // FIND X AT CIRCLES EDGE
   MyX = iifF(MyX<0,0,MyX);
   MyX = iifF(MyX>1,1,MyX);
   return (MyX);
}
float GetZPointOnCircle(float Angle=0, float Radius=0, float AtZ=.5) {
   float MyZ = (Radius * sin(Angle) + AtZ); // FIND Z AT CIRCLES EDGE
   MyZ = iifF(MyZ<0,0,MyZ);
   MyZ = iifF(MyZ>1,1,MyZ);
   return (MyZ);
}
int ObjectsInACircle(int id=0, float StartAngle=0, float EndAngle=0, float AngleBetween=0, float Radius=0, float StartX=.5, float StartZ=.5, int PlayerId=0, int Count=0) {
   // RADIUS AS FRACTION, WIDTH IN METERS
   float ThisAngle=iifF(EndAngle<StartAngle,(EndAngle+360)-StartAngle,EndAngle-StartAngle);
   int NumberOfAngles = (ThisAngle)/AngleBetween; // NUMBER OF ANGLES BETWEEN
   ThisAngle = StartAngle;
   for (i=0; <=NumberOfAngles) {
      float MyAtX=GetXPointOnCircle(ThisAngle, Radius, StartX);
      float MyAtZ=GetZPointOnCircle(ThisAngle, Radius, StartZ);
      ThisAngle=ThisAngle+AngleBetween;
      rmPlaceObjectDefAtLoc(id, PlayerId, MyAtX, MyAtZ, Count);
   }
   return(id);
}
/* SKINNING FUNCTIONS  ************************************/
float GetAnimalValue(string Animal="") {
   // RETURNS THE FOOD VALUE FOR FOOD TYPES, OR HIT POINTS FOR PREDATORS
   // USED TO HELP DETERMINE THE NUMBER OF EACH TYPE TO PLACE
   // THESE ARE NUTRITIONAL VALUES
   if (Animal=="Aurochs") return (400.0);
   if (Animal=="Baboon") return (80.0);
   if (Animal=="Berry Bush") return (100.0);
   if (Animal=="Boar") return (300.0);
   if (Animal=="Caribou") return (150.0);
   if (Animal=="Chicken") return (75.0);
   if (Animal=="Cow") return (75.0);
   if (Animal=="Crocodile") return (200.0);
   if (Animal=="Crowned Crane") return (100.0);
   if (Animal=="Deer") return (150.0);
   if (Animal=="Elephant") return (750.0);
   if (Animal=="Elk") return (150.0);
   if (Animal=="Fish - Mahi") return (100.0);
   if (Animal=="Fish - Perch") return (100.0);
   if (Animal=="Fish - Salmon") return (100.0);
   if (Animal=="Gazelle") return (100.0);
   if (Animal=="Giraffe") return (100.0);
   if (Animal=="Goat") return (60.0);
   if (Animal=="Hippo") return (400.0);
   if (Animal=="Monkey") return (100.0);
   if (Animal=="Pig") return (65.0);
   if (Animal=="Rhinocerous") return (500.0);
   if (Animal=="Walrus") return (100.0);
   if (Animal=="Water Buffalo") return (100.0);
   if (Animal=="Zebra") return (200.0);
   // THESE ARE HITPOINTS
   if (Animal=="Ape Of Set") return (45.0);
   if (Animal=="Bear") return (90.0);
   if (Animal=="Hyena") return (80.0);
   if (Animal=="Hyena Of Set") return (45.0);
   if (Animal=="Lion") return (60.0);
   if (Animal=="Polar Bear") return (90.0);
   if (Animal=="Rhinocerous Of Set") return (180.0);
   if (Animal=="Shade of erebus") return (90.0);
   if (Animal=="Serpent") return (90.0);
   if (Animal=="Wolf") return (45.0);
   rmEchoInfo("Animal not found="+Animal);
   return(1000.0);
}
string GetAnimalType(int HerdHuntFishPred=0) {
   // RANDOMLY SELECT AN ANIMAL BASED ON MapSkin
   int thisskin=MapSkin;
   int rand=0;
   if (thisskin==0) thisskin = rmRandInt(1,5); // RANDOM TYPE
   if (HerdHuntFishPred==1) { // LOOKING FOR HERDABLE TYPE
      if (thisskin==1) {// WINTER HERDABLE
         rand = rmRandInt(1,4);
         if (rand==1) return("Berry Bush");
         else if (rand==2) return("Pig");
         else if (rand==3) return("goat");
         else if (rand==4) return("Cow");
      }
      if (thisskin==2) {// SPRING HERDABLE
         rand = rmRandInt(1,4);
         if (rand==1) return("Berry Bush");
         else if (rand==2) return("Goat");
         else if (rand==3) return("Pig");
         else if (rand==4) return("Crowned Crane");
      }
      if (thisskin==3) {// SUMMER HERDABLE
         rand = rmRandInt(1,4);
         if (rand==1) return("Berry Bush");
         else if (rand==2) return("Aurochs");
         else if (rand==3) return("Cow");
         else if (rand==4) return("Crowned Crane");
      }
      if (thisskin==4) {// FALL HERDABLE
         rand = rmRandInt(1,3);
         if (rand==1) return("Berry Bush");
         else if (rand==2) return("Goat");
         else if (rand==3) return("Pig");
      }
      if (thisskin==5) {// MORDOR HERDABLE
         rand = rmRandInt(1,3);
         if (rand==1) return("Berry Bush");
         else if (rand==2) return("Aurochs");
         else if (rand==3) return("Pig");
      }
   } else if (HerdHuntFishPred==2) { // LOOKING FOR HUNTABLE
      if (thisskin==1 || thisskin==4) {// WINTER/FALL HUNTABLE
         rand = rmRandInt(1,3+WaterOnMap); // A 1 IF SEA TO POSSIBLY PLACE A WATER TYPE ANIMAL
         if (rand==1) return("Caribou");
         else if (rand==2) return("Deer");
         else if (rand==3) return("Elk");
      }
      if (thisskin==2) {// SPRING HUNTABLE
         rand = rmRandInt(1,6+WaterOnMap);
         if (rand==1) return("Gazelle");
         else if (rand==2) return("Giraffe");
         else if (rand==3) return("Rhinocerous");
         else if (rand==4) return("Elephant");
         else if (rand==5) return("Hippo");
         else if (rand==6) return("Zebra");
      }
      if (thisskin==3) {// SUMMER HUNTABLE
         rand = rmRandInt(1,3+WaterOnMap);
         if (rand==1) return("Monkey");
         else if (rand==2) return("Baboon");
         else if (rand==3) return("Boar");
         if (rand==1) return("Giraffe");
      }
      if (thisskin==5) {// MORDOR HUNTABLE
         rand = rmRandInt(1,3);
         if (rand==1) return("Baboon");
         else if (rand==2) return("Boar");
         else if (rand==3) return("Rhinocerous");
      }
      rand = rmRandInt(1,2); // IF A SEA MAP, THEN PLACE A WATER TYPE ANIMAL
      if (rand==1) return("Walrus");
      else if (rand==2) return("Water Buffalo");
   } else if (HerdHuntFishPred==3) { // LOOKING FOR FISHABLE
      rand = rmRandInt(1,3);
      if (rand==1) return("Fish - Mahi");
      else if (rand==2) return("Fish - Perch");
      else if (rand==3) return("Fish - Salmon");
   } else if (HerdHuntFishPred==4) { // LOOKING FOR PREDATORS
      if (thisskin==1 || thisskin==4) {// WINTER/FALL PREDATORS
         rand = rmRandInt(1,3);
         if (rand==1) return("Polar Bear");
         else if (rand==2) return("Wolf");
         else if (rand==3) return("Bear");
      }
      if (thisskin==2 || thisskin==3) {// SPRING/SUMMER PREDATORS
         rand = rmRandInt(1,6+WaterOnMap);
         if (rand==1) return("Hyena");
         else if (rand==2) return("Lion");
         else if (rand==3) return("Serpent");
         else if (rand==4) return("Bear");
         else if (rand==5) return("Ape Of Set");
         else if (rand==6) return("Hyena Of Set");
      }
      if (thisskin==5) {// MORDOR PREDATORS
         rand = rmRandInt(1,5);
         if (rand==1) return("Serpent");
         else if (rand==2) return("Shade of erebus");
         else if (rand==3) return("Ape Of Set");
         else if (rand==4) return("Hyena Of Set");
         else if (rand==5) return("Rhinoceros Of Set");
      }
      return("Crocodile"); // IF WATER MAP AND NONE SELECTED
   }
}

int CreateAnimals(string ObjName="", int HerdHuntFishPred=0, float Points=0.0, int MinDist=0, int MaxDist=0, int AddToClass=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   string Animal = GetAnimalType(HerdHuntFishPred);
   float NumToPlace = Points/GetAnimalValue(Animal);
   NumToPlace = iifF(NumToPlace<1,1,NumToPlace); // ALWAYS PLACE AT LEAST ONE
   NumToPlace = rmRandInt(NumToPlace*.8,NumToPlace*1.2); // USE A 20% VARIANCE ON THE NUMBER PLACE; REQUEST FOR 10 TO GET 8-12
   int id=rmCreateObjectDef("Animal"+ObjName);
   rmAddObjectDefItem(id, Animal, NumToPlace, 2.0);
   rmSetObjectDefMinDistance(id, MinDist);
   rmSetObjectDefMaxDistance(id, MaxDist);
   if (AddToClass>0) rmAddObjectDefToClass(id, AddToClass);
   if (Constraint1>0) rmAddObjectDefConstraint(id, Constraint1);
   if (Constraint2>0) rmAddObjectDefConstraint(id, Constraint2);
   if (Constraint3>0) rmAddObjectDefConstraint(id, Constraint3);
   if (Constraint4>0) rmAddObjectDefConstraint(id, Constraint4);
   if (Animal=="Walrus" || Animal=="Water Buffalo" || Animal=="Crocodile") rmAddObjectDefConstraint(id, nearShoreLineVeryShort);
   rmPlaceObjectDefPerPlayer(id, false, 1);
   return(id);
}

void PlaceGold(int Amount=0, int idTiny=0, int idSmall=0, int idLarge=0) {
   int RemainAmount = Amount;
   int j=0;
   for (i=1; <cNumberPlayers*2) { // ONLY LOOP SO MANY TIMES REGARDLESS OF REQUEST AMOUNT
      if (RemainAmount < cGoldAmtTiny/2) break; // NOT AT LEAST 1/2 A TINY TO PLACE, SO EXIT LOOP
      if (RemainAmount<cGoldAmtSmall) j=1; // NOT ENOUGH FOR SMALL, MUST BE TINY
      else if (RemainAmount<cGoldAmtLarge) j=2; // NOT ENOUGH FOR LARGE, MUST BE SMALL
      else j = rmRandInt(1,3); // RANDOMLY PICK A SIZE
      if (j == 1) {
         RemainAmount = RemainAmount - cGoldAmtTiny;
         rmPlaceObjectDefPerPlayer(idTiny,false,1);
      } else if (j == 2) {
         RemainAmount = RemainAmount - cGoldAmtSmall;
         rmPlaceObjectDefPerPlayer(idSmall,false,1);
      } else if (j == 3) {
         RemainAmount = RemainAmount - cGoldAmtLarge;
         rmPlaceObjectDefPerPlayer(idLarge,false,1);
      }
   }
}

void CreateGold(int CloseAmount=0, float ClostDist=0, int NearByAmount=0, float NearByDist=0, int FarAmount=0, float FarDist=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   int idTiny = rmCreateObjectDef("GoldTiny");
   rmAddObjectDefItem(idTiny,"Gold Mine Tiny",1,0.0);
   rmSetObjectDefMinDistance(idTiny,10.0);
   rmSetObjectDefMaxDistance(idTiny,ClostDist);
   if (Constraint1>0) rmAddObjectDefConstraint(idTiny, Constraint1);
   if (Constraint2>0) rmAddObjectDefConstraint(idTiny, Constraint2);
   if (Constraint3>0) rmAddObjectDefConstraint(idTiny, Constraint3);
   if (Constraint4>0) rmAddObjectDefConstraint(idTiny, Constraint4);
   int idSmall = rmCreateObjectDef("GoldSmall");
   rmAddObjectDefItem(idSmall,"Gold Mine Small",1,0.0);
   rmSetObjectDefMinDistance(idSmall,ClostDist+1);
   rmSetObjectDefMaxDistance(idSmall,NearByDist);
   if (Constraint1>0) rmAddObjectDefConstraint(idSmall, Constraint1);
   if (Constraint2>0) rmAddObjectDefConstraint(idSmall, Constraint2);
   if (Constraint3>0) rmAddObjectDefConstraint(idSmall, Constraint3);
   if (Constraint4>0) rmAddObjectDefConstraint(idSmall, Constraint4);
   int idLarge = rmCreateObjectDef("GoldLarge");
   rmAddObjectDefItem(idLarge,"Gold Mine",1,0.0);
   rmSetObjectDefMinDistance(idLarge,NearByDist+1);
   rmSetObjectDefMaxDistance(idLarge,FarDist);
   if (Constraint1>0) rmAddObjectDefConstraint(idLarge, Constraint1);
   if (Constraint2>0) rmAddObjectDefConstraint(idLarge, Constraint2);
   if (Constraint3>0) rmAddObjectDefConstraint(idLarge, Constraint3);
   if (Constraint4>0) rmAddObjectDefConstraint(idLarge, Constraint4);
   PlaceGold(CloseAmount, idTiny, idSmall, idLarge);
   PlaceGold(NearByAmount, idTiny, idSmall, idLarge);
   PlaceGold(FarAmount, idTiny, idSmall, idLarge);
}

string GetBirdType() {
   int thisskin=MapSkin;
   if (thisskin==0) thisskin = rmRandInt(1,5); // RANDOM TYPE
   if (rmRandInt(1,10)==1 && MapSkin==5) return("Flying Purple Hippo"); // Whee! - Only MORDER
   if (rmRandInt(1,10)==1) return("Harpy"); // Controlable
   else if (thisskin==1) return("Vulture"); // WINTER
   else if (thisskin==2) return("Hawk"); // SPRING
   else if (thisskin==3) return("Hawk"); // SUMMER
   else if (thisskin==4) return("Vulture"); // FALL
   else if (thisskin==5) return("Harpy"); // MORDER
}

string GetWaterType() {
   int thisskin=MapSkin;
   if (thisskin==0) thisskin = rmRandInt(1,5); // RANDOM TYPE
   if (thisskin==1) return("Norse River"); // WINTER
   else if (thisskin==2) return("Savannah Water Hole"); // SPRING
   else if (thisskin==3) return("Greek River"); // SUMMER
   else if (thisskin==4) return("Norwegian Sea");// FALL
   else if (thisskin==5) return("Styx River"); // MORDOR
}

string GetLandType() {
   int thisskin=MapSkin;
   if (thisskin==0) thisskin = rmRandInt(1,5); // RANDOM TYPE
   if (thisskin==1) return("CliffNorseB"); // WINTER
   else if (thisskin==2) return("SavannahA"); // SPRING
   else if (thisskin==3) return("GrassA"); // SUMMER
   else if (thisskin==4) return("SnowGrass75"); // FALL
   else if (thisskin==5) return("ForestFloorDeadPine"); // MORDOR
}

string GetTreeType(int ForestOrTreeType=0) {
   int thisskin=MapSkin;
   if (thisskin==0) thisskin = rmRandInt(1,5); // RANDOM TYPE
   if (ForestOrTreeType==1) { // LOOKING FOR A FOREST TYPE
      if (thisskin==1) { // WINTER
         thisskin=rmRandInt(1,2);
         if (thisskin==1) return("Snow Pine Forest");
         else if (thisskin==2) return("Mixed Pine Forest");
      }
      else if (thisskin==2) return("Savannah Forest"); // SPRING
      else if (thisskin==3) { // SUMMER
         thisskin=rmRandInt(1,4);
         if (thisskin==1) return("Mixed Oak Forest");
         else if (thisskin==2) return("Pine Forest");
         else if (thisskin==3) return("Oak Forest");
         else if (thisskin==4) return("Palm Forest");
      }
      else if (thisskin==4) { // FALL
         thisskin=rmRandInt(1,2);
         if (thisskin==1) return("Autumn Oak Forest");
         else if (thisskin==2) return("Pine Forest");
      }
      else if (thisskin==5) return("Hades Forest"); // MORDOR
   } else { // INDIVIDUAL TREE
      if (thisskin==1) return("Pine Snow"); // WINTER
      else if (thisskin==2) return("Savannah Tree"); // SPRING
      else if (thisskin==3) {
         thisskin=rmRandInt(1,3);
         if (thisskin==1) return("Oak Tree");
         else if (thisskin==2) return("Pine");
         else if (thisskin==3) return("Palm");
      }
      else if (thisskin==4) {
         thisskin=rmRandInt(1,2); // FALL
         if (thisskin==1) return("Oak Autumn");
         else if (thisskin==2) return("Pine");
      }
      else if (thisskin==5) return("Pine Dead"); // MORDOR
   }
}

string GetCliffType() {
   int thisskin=MapSkin;
   if (thisskin==0) thisskin = rmRandInt(1,5); // RANDOM TYPE
   if (thisskin==1) return("Norse"); // WINTER
   else if (thisskin==2) return("Egyptian"); // SPRING
   else if (thisskin==3) return("Greek"); // SUMMER
   else if (thisskin==4) return("Norse"); // FALL
   else if (thisskin==5) return("Hades"); // MORDOR
}

string GetRockType(string Size="") {
   int thisskin=MapSkin;
   if (thisskin==0) thisskin = rmRandInt(1,5); // RANDOM TYPE
   if (thisskin==1) {
      if (rmRandInt(1,10)>1) return("Rock Granite "+Size); // WINTER
      else return ("Rock River Icy");
   }
   else if (thisskin==2 || thisskin==3) return("Rock Sandstone "+Size); // SPRING/SUMMER
   else if (thisskin==4) return("Rock Limestone "+Size); // FALL
   else if (thisskin==5) return("Stalagmite"); // MORDOR
   /* Look into these: Rock Cliff, Rock River Grassy, Rock River Icy, Rock River Sandy, Rock Snow, Rock Symbols */
}

string GetRoadType() {
   int thisskin=MapSkin;
   if (thisskin==0) thisskin = rmRandInt(1,5); // RANDOM TYPE
   if (thisskin==1) return("NorseRoadA"); // WINTER
   else if (thisskin==2) return("GreekRoadA"); // SPRING
   else if (thisskin==3) { // SUMMER
      if (rmRandInt(2,2)==1) return("CityTileA");
      return("CityTileAtlantis");
   }
   else if (thisskin==4) return("NorseRoadA"); // FALL
   else if (thisskin==5) return("UnderWaterRockC"); // MORDOR
}

string GetWaterPlant() {
   if (rmRandInt(1,50)==1) return ("Sea Snake"); // ssss
   if (rmRandInt(1,100)==1) return("monkey raft");// HAVE SOME FUN WILL YA?
   if (rmRandInt(1,100)==1) return("Sea Turtle");// WICKED
   if (rmRandInt(1,100)==1) return("Jormund Elver");// OLLIE
   int thisskin=rmRandInt(1,6);
   if (thisskin==1) return("water lilly");
   else if (thisskin==2) return("papyrus");
   else if (thisskin==3) return("Water decoration");
   else if (thisskin==4) return("Water Reeds");
   else if (thisskin==5) return("Seaweed");
   else if (thisskin==6) return("Hawksbill"); // I Know
}

string GetBigFish() {
   int thisskin= rmRandInt(1,3);
   if (thisskin==1) return("Orca");
   else if (thisskin==2) return("Whale");
   else if (thisskin==3) return("Shark");
}

void LayerTerrain(int id=0, float Width=6) {
   // WIDTH IN METERS!! - Layers starting at 0 go from outer edge toward area center
   int thisskin=MapSkin;
   if (thisskin==0) thisskin = rmRandInt(1,5); // RANDOM TYPE
   if (thisskin==1) { // WINTER
      rmAddAreaTerrainLayer(id,"SnowA",0, Width * .33);
      rmAddAreaTerrainLayer(id,"SnowGrass50",Width * .33,Width * .66);
      rmAddAreaTerrainLayer(id,"SnowGrass25",Width * .66,Width);
   } else if (thisskin==2) { // SPRING
      rmAddAreaTerrainLayer(id,"SavannahC",0, Width * .25);
      rmAddAreaTerrainLayer(id,"SavannahD", Width * .25,Width * .5);
      rmAddAreaTerrainLayer(id,"SavannahC", Width * .5,Width * .75);
      rmAddAreaTerrainLayer(id,"SavannahB", Width * .75,Width);
   } else if (thisskin==3) { // SUMMER
      rmAddAreaTerrainLayer(id,"GrassDirt25",0, Width * .25);
      rmAddAreaTerrainLayer(id,"CliffGreekB", Width * .25,Width * .5);
      rmAddAreaTerrainLayer(id,"GrassDirt50", Width * .5,Width * .75);
      rmAddAreaTerrainLayer(id,"GrassDirt25", Width * .75,Width);
   } else if (thisskin==4) { // FALL
      rmAddAreaTerrainLayer(id,"SnowGrass75",0, Width * .25);
      rmAddAreaTerrainLayer(id,"CliffNorseB", Width * .25,Width * .5);
      rmAddAreaTerrainLayer(id,"SnowGrass50", Width * .5,Width * .75);
      rmAddAreaTerrainLayer(id,"CliffNorseB", Width * .75,Width);
   } else if (thisskin==5) { // MORDOR
      rmAddAreaTerrainLayer(id,"UnderWaterRockA",0,Width * .5);
      rmAddAreaTerrainLayer(id,"HadesBuildable2",Width * .5,Width);
   }
}

void SetMainLandType(int id=0, int LayerWidth=0, int Height=2, string ForceType="") {
   if (ForceType=="") {
      rmSetAreaTerrainType(id,GetLandType());
      LayerTerrain(id, LayerWidth);
   } else {
      rmSetAreaTerrainType(id,ForceType);
   }
   rmSetAreaSmoothDistance(id,6);
   rmSetAreaBaseHeight(id,Height);
}

void SetMainWaterType(int id=0) {
   rmSetAreaWaterType(id, GetWaterType());
}

void AddRocks(int Num=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   string type="sprite";
   for (i=1; <=3) {
      if (i==2) type="small";
      else if (i==3) type="big";
      if (Num>0) {
         int id=rmCreateObjectDef("rock "+type);
         rmAddObjectDefItem(id, GetRockType(type), 1, 0.0);
         rmSetObjectDefMinDistance(id, 0.0);
         rmSetObjectDefMaxDistance(id, rmXFractionToMeters(0.5));
         if (Constraint1>0) rmAddObjectDefConstraint(id, Constraint1);
         if (Constraint2>0) rmAddObjectDefConstraint(id, Constraint2);
         if (Constraint3>0) rmAddObjectDefConstraint(id, Constraint3);
         if (Constraint4>0) rmAddObjectDefConstraint(id, Constraint4);
         rmPlaceObjectDefAtLoc(id, 0, 0.5, 0.5, Num);
      }
   }
}


/* AREA FUNCTIONS  ************************************/
int CreateAreaAtXZ(string ObjName="", float AtX=.5, float AtZ=.5, float WidthX=0, float WidthZ=0, float HeightBlend=2, float Coherence=1) {
   int id = rmCreateArea(ObjName);
   rmSetAreaHeightBlend(id,HeightBlend);
   if (AtX>-1 && AtZ>-1) rmSetAreaLocation(id,AtX,AtZ);
   rmSetAreaSize(id,WidthX,WidthZ);
   rmSetAreaCoherence(id,Coherence);
   return (id);
}

void BlobulateArea(int id=0, int MinBlobs=0, int MinBlobDist=0,  int MaxBlobs=0, int MaxBlobDist=0) {
   rmSetAreaMinBlobs(id,MinBlobs);
   rmSetAreaMaxBlobs(id,MaxBlobs);
   rmSetAreaMinBlobDistance(id, MinBlobDist);
   rmSetAreaMaxBlobDistance(id, MaxBlobDist);
}

void LandArea(string ObjName="", int numAreas=0, float MinHeight=0.0, float MaxHeight=0.0, float CliffHeight=0.0, float WidthX=0, float WidthZ=0, int AddToClass=0, int Constraint1=0, int Constraint2=0, int Constraint3=0) {
   int failCount=0;
   float ThisHeight=0;
   float NumCliffs=rmRandFloat(1,3);
   for(i=0; <numAreas) {
      int id = CreateAreaAtXZ(ObjName+"beauty"+i, -1, -1, rmZMetersToFraction(WidthX), rmZMetersToFraction(WidthZ), 3, 0);
      rmSetAreaWarnFailure(id, false);
      ThisHeight=rmRandFloat(MinHeight, MaxHeight);
      SetMainLandType(id, 10, ThisHeight);
      BlobulateArea(id, 1, rmRandInt(10, 16),  rmRandInt(3, 10), rmRandInt(16, 25));
      if (AddToClass>0) rmAddAreaToClass(id, AddToClass);
      if (Constraint1>0) rmAddAreaConstraint(id, Constraint1);
      if (Constraint2>0) rmAddAreaConstraint(id, Constraint2);
      if (Constraint3>0) rmAddAreaConstraint(id, Constraint3);
      if (ThisHeight>=CliffHeight || ThisHeight<=(0-CliffHeight)) { // MAKE TALL AREAS CLIFFS/LOW AREAS GORGES
         rmSetAreaCliffType(id, GetCliffType());
         rmSetAreaCliffEdge(id, NumCliffs, 1.0/NumCliffs, 0.1, 1.0, 0);
         rmSetAreaCliffPainting(id, true, true, true, 1.5, true);
         rmSetAreaCliffHeight(id, 3, 1.0, 1.0);//ThisHeight
      }
      if(rmBuildArea(id)==false) { // Stop trying once we fail 3 times in a row.
         failCount++;
         if (failCount==3) break;
      } else failCount=0;
   }
}

void ForestArea(string ObjName="", int numAreas=0, float MinHeight=0.0, float MaxHeight=0.0, float WidthX=0, float WidthZ=0, int AddToClass=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   int failCount=0;
   float ThisHeight=0;
   float NumCliffs=rmRandFloat(1,3);
   int tree1id=rmCreateObjectDef("random tree1"+ObjName); // SCATTER RANDOM TREES AS WELL
   rmAddObjectDefItem(tree1id, GetTreeType(0), 5, 1);
   int tree2id=rmCreateObjectDef("random tree2"+ObjName); // SCATTER RANDOM TREES AS WELL
   rmAddObjectDefItem(tree2id, GetTreeType(0), 5, 1);
   int tree3id=rmCreateObjectDef("random tree3"+ObjName); // SCATTER RANDOM TREES AS WELL
   rmAddObjectDefItem(tree3id, GetTreeType(0), 5, 1);

   int tree4id=rmCreateObjectDef("random tree"+ObjName); // THIS FOR PLAYER AREA
   rmAddObjectDefItem(tree4id, GetTreeType(0), 1, 0.0);
   rmSetObjectDefMinDistance(tree4id, iifF(MapSkin==5,40.0,10.0));// NO BURNING TREES ON
   rmSetObjectDefMaxDistance(tree4id, iifF(MapSkin==5,70.0,25.0));// OUR LAWN PLEASE
   rmPlaceObjectDefPerPlayer(tree4id, false, 7); // FOR THE PLAYER AREAS

   if (Constraint1>0) rmAddObjectDefConstraint(tree4id, Constraint1);
   if (Constraint2>0) rmAddObjectDefConstraint(tree4id, Constraint2);
   if (Constraint3>0) rmAddObjectDefConstraint(tree4id, Constraint3);
   if (Constraint4>0) rmAddObjectDefConstraint(tree4id, Constraint4);
   rmSetObjectDefMinDistance(tree4id, 0.0);
   rmSetObjectDefMaxDistance(tree4id, rmZFractionToMeters(.5));

   if (WaterOnMap==1) {
      rmSetObjectDefMinDistance(tree4id, 0.3);
      rmAddObjectDefConstraint(tree1id, nearShoreLineVeryShort);
      rmAddObjectDefConstraint(tree2id, nearShoreLineVeryShort);
      rmAddObjectDefConstraint(tree3id, nearShoreLineVeryShort);
      rmAddObjectDefConstraint(tree4id, nearShoreLineVeryShort);
   }
   rmPlaceObjectDefAtLoc(tree1id, 0, 0.5, 0.5, 10*numAreas); // RANDOMLY AROUND THE MAP
   rmPlaceObjectDefAtLoc(tree2id, 0, 0.5, 0.5, 10*numAreas); // RANDOMLY AROUND THE MAP
   rmPlaceObjectDefAtLoc(tree3id, 0, 0.5, 0.5, 10*numAreas); // RANDOMLY AROUND THE MAP
   rmPlaceObjectDefAtLoc(tree4id, 0, 0.5, 0.5, 10*numAreas); // RANDOMLY AROUND THE MAP
   for(i=0; <numAreas) {
      int impassable=rmRandInt(1,cNumberPlayers);
      int id = CreateAreaAtXZ(ObjName+"forest"+i, -1, -1, rmZMetersToFraction(WidthX/(impassable+1)), rmZMetersToFraction(WidthZ/(impassable+1)), 2, 0);
      rmSetAreaWarnFailure(id, false);
      LayerTerrain(id, 6);
//      ThisHeight=rmRandFloat(MinHeight, MaxHeight);
//      SetMainLandType(id, 6, ThisHeight);
//      BlobulateArea(id, 1, rmRandInt(10, 16),  rmRandInt(3, 10), rmRandInt(16, 25));
      if (Constraint1>0) rmAddAreaConstraint(id, Constraint1);
      if (Constraint2>0) rmAddAreaConstraint(id, Constraint2);
      if (Constraint3>0) rmAddAreaConstraint(id, Constraint3);
      if (Constraint4>0) rmAddAreaConstraint(id, Constraint4);
      if (impassable==1) {
         rmSetAreaForestType(id,GetTreeType(1));
         if (AddToClass>0) rmAddAreaToClass(id, AddToClass); // ONLY ADD INPASSABLE FOREST TO CLASS
      }
      if(rmBuildArea(id)==false) { // Stop trying once we fail 3 times in a row.
         failCount++;
         if (failCount==3) break;
      } else failCount=0;
      if (impassable>1) rmPlaceObjectDefInArea(tree1id,0,id,10);
      if (impassable>1) rmPlaceObjectDefInArea(tree2id,0,id,10);
      if (impassable>1) rmPlaceObjectDefInArea(tree3id,0,id,10);
      if (impassable>1) rmPlaceObjectDefInArea(tree4id,0,id,10);
   }
}

void BeautifyWater(string ObjName="", int id=0, int AddFish=0,  int Embellish=0, int Class=0) {
   int NumToPlace = rmRandInt(AddFish,AddFish*1.2); // USE A 20% VARIANCE ON THE NUMBER PLACE; REQUEST FOR 10 TO GET 10-12
   if (NumToPlace>0) { // ADD SOME FISH TO THE WATER
      int fishid = rmCreateObjectDef(ObjName+"fish");
      rmAddObjectDefItem(fishid,GetAnimalType(3),1,0.0);
      if (Class==0) rmPlaceObjectDefInArea(fishid, 0, id, NumToPlace);
      else rmPlaceObjectDefInRandomAreaOfClass(fishid, 0, id, NumToPlace);
   }
   NumToPlace = rmRandInt(Embellish,Embellish*1.2); // USE A 20% VARIANCE ON THE NUMBER PLACE; REQUEST FOR 10 TO GET 10-12
   if (NumToPlace>0) { // ADD SOME PLANT LIFE TO THE WATER
      int plantid = rmCreateObjectDef(ObjName+"plant");
      rmAddObjectDefItem(plantid,GetWaterPlant(),3,1.0); // 3 per
      if (Class==0) rmPlaceObjectDefInArea(plantid, 0, id, NumToPlace);
      else rmPlaceObjectDefInRandomAreaOfClass(plantid, 0, id, NumToPlace);
   }
}

void WaterArea(string ObjName="", int numAreas=0, float WidthX=0, float WidthZ=0, int AddFish=0, int Embellish=0, int AddToClass=0, int Constraint1=0, int Constraint2=0, int Constraint3=0) {
   int failCount=0;
   float ThisHeight=0;
   float NumCliffs=rmRandFloat(1,3);
   for(i=0; <numAreas) {
      int id = CreateAreaAtXZ(ObjName+"water"+i, -1, -1, rmZMetersToFraction(WidthX), rmZMetersToFraction(WidthZ), 2, 0);
      rmSetAreaWarnFailure(id, false);
      SetMainWaterType(id);
      BlobulateArea(id, 3, rmRandInt(5, 10),  rmRandInt(10, 20), rmRandInt(10, 25));
      rmSetAreaBaseHeight(id,-4);
      if (AddToClass>0) rmAddAreaToClass(id, AddToClass);
      if (Constraint1>0) rmAddAreaConstraint(id, Constraint1);
      if (Constraint2>0) rmAddAreaConstraint(id, Constraint2);
      if (Constraint3>0) rmAddAreaConstraint(id, Constraint3);
      if(rmBuildArea(id)==false) { // Stop trying once we fail 3 times in a row.
         failCount++;
         if (failCount==3) break;
      } else failCount=0;
      for(j=1; <=AddFish) BeautifyWater(ObjName+"fish"+i+"_"+j, id, 1, 0);
      for(j=1; <=Embellish) BeautifyWater(ObjName+"plants"+i+"_"+j, id, 0, 1);
   }
}

void FlamingMoat(string ObjName="",float Angle=0, float AngleBetween=0, float Radius=0, float AtX=0, float AtZ=0) {
   int id = rmCreateObjectDef(ObjName);
   rmAddObjectDefItem(id,"Fire Hades",3,1.0);
   ObjectsInACircle(id, Angle+20, Angle-20, AngleBetween, Radius, AtX, AtZ, 0, 1);
}


void PlayerStash(string ObjName="", float AtX=0, float AtZ=0, int Constraint1=0) {
   int id = CreateAreaAtXZ("PlayerStash"+ObjName, AtX, AtZ, rmZMetersToFraction(2),rmZMetersToFraction(2), 2, 1);
   rmSetAreaForestType(id, GetTreeType(1));
   SetMainLandType(id, 6, 0);
   rmSetAreaBaseHeight(id,SeaLevel+3);
   rmBuildArea(id);
   id = CreateAreaAtXZ("FoodStash"+ObjName, AtX, AtZ, rmZMetersToFraction(3),rmZMetersToFraction(3), 2, 1);
   rmBuildArea(id);
   int xid = rmCreateObjectDef(ObjName);
   rmAddObjectDefItem(xid,"Berry Bush",5,.5);
   rmAddObjectDefConstraint(xid, rmCreateTypeDistanceConstraint("Avoid trees"+ObjName, "tree", .5));
   if (Constraint1>0) rmAddObjectDefConstraint(xid, Constraint1);
   rmPlaceObjectDefInArea(xid,0,id,20);
}

void BuildMountainAtXZ(string ObjName="", float Angle=0, float AtX=0, float AtZ=0, float BaseWidth=0, float Height=0, int Steps=0, int PlayerId=0, int classPlayer=0) {
   // WIDTH HERE IS FRACTION OF MAP
   float WaterAdj = iifF(WaterOnMap==0,.01,.5);
   int id = CreateAreaAtXZ("PlayerMoat"+ObjName, AtX, AtZ, BaseWidth * (3.35+WaterAdj),BaseWidth * (3.35+WaterAdj), 2, 1);
   rmSetAreaBaseHeight(id,SeaLevel+3);
   SetMainWaterType(id);
   rmAddAreaToClass(id, classPlayer);
   rmBuildArea(id);
   string TopSurface="";
   id = CreateAreaAtXZ("PlayerBeach"+ObjName, AtX, AtZ, BaseWidth * 1.65, BaseWidth * 1.65, 2, 1);
   SetMainLandType(id, 6, 0);
   rmAddAreaToClass(id, classPlayer);
   rmBuildArea(id);
   for (i=0;<=Steps) {
      float ThisWidth = BaseWidth-BaseWidth/Steps * (i-1); // 0 LEVEL IS BUILT LARGER THAN REQUESTED SIZE TO MAKE A BEACH ON WATER MAPS
      float MyAtX=GetXPointOnCircle(Angle, BaseWidth + (BaseWidth-ThisWidth)*1.2, AtX); // PUT EACH LAYER ON BACK EDGE OF PREVIOUS
      float MyAtZ=GetZPointOnCircle(Angle, BaseWidth + (BaseWidth-ThisWidth)*1.2, AtZ); // PUT EACH LAYER ON BACK EDGE OF PREVIOUS*.8175
      float ThisHeight = (Height-SeaLevel+2) * i/Steps+SeaLevel;
      float ThisConherence=(.25+.5/Steps*i); // START WILD AND SET STRUCTURED - GO FROM .25 to .75
      float ThisHeightBlend=(3-(i % 5)); // START VERY SMOOTH AND GET RIGID - GO FROM 4 ON BASE LEVEL TO 0 -
      if (ThisHeightBlend<0) ThisHeightBlend=0; // NEVER GO NEGATIVE
      if (i==0) {
         ThisHeight = SeaLevel+2;
         ThisHeightBlend=3; // FIRST LEVEL BLENDS INTO GROUND WELL
      }
      if (i==Steps) TopSurface=GetRoadType();
      id = CreateAreaAtXZ(ObjName+i, MyAtX, MyAtZ, ThisWidth, ThisWidth, ThisHeightBlend ,1); //ThisConherence);
      SetMainLandType(id, 6, ThisHeight,TopSurface);
      if (i>0) { // FIRST LEVEL IS NOT A CLIFF
         rmSetAreaCliffType(id, GetCliffType());
         //rmSetAreaCliffEdge(id, 0, 1.0, 0.0, 1.0, 0); - crashes AOM
         rmSetAreaCliffEdge(id, 1, 1.0, 0.0, 1.0, 0);
         rmSetAreaCliffPainting(id, true, true, true, 1.5, true);
         rmSetAreaCliffHeight(id, 4, 1.0, 1.0);
      }
      rmAddAreaToClass(id, classPlayer);
      rmBuildAllAreas();
   }
   if (PlayerId>0) {
      rmPlacePlayer(PlayerId,MyAtX,MyAtZ);
      rmSetPlayerArea(PlayerId, id);
   }
   if (MapSkin==5) {
      FlamingMoat("FlamingMoe1"+Angle,(Angle+180) % 360,5,BaseWidth * 6.2,AtX, AtZ);
      FlamingMoat("FlamingMoe2"+Angle,(Angle+180) % 360,5,BaseWidth * 6,AtX, AtZ);
      FlamingMoat("FlamingMoe3"+Angle,(Angle+180) % 360,5,BaseWidth * 5.8,AtX, AtZ);
      FlamingMoat("FlamingMoe4"+Angle,(Angle+180) % 360,5,BaseWidth * 5.6,AtX, AtZ);
   }
}

int MakeRamp(string ObjName="", float Angle=0, float LineLength=0, float NumSteps=1, float StartX=.5, float StartZ=.5, float StartHeight=15, float Width=0, int classRamp=0) {
   // LineLength  SPACEBETWEEN AS METERS!
   float NextPoint=0;
   float Riser=(StartHeight-SeaLevel+1)/NumSteps;
   int StepsLength = LineLength/NumSteps;
   for (i=(NumSteps * .35); <NumSteps*.9) { // MY OWN HEIGHT BLENDING
      NextPoint = rmZMetersToFraction(i * LineLength/NumSteps);
      float MyAtX=GetXPointOnCircle(Angle, NextPoint, StartX);
      float MyAtZ=GetZPointOnCircle(Angle, NextPoint, StartZ);
      int id = CreateAreaAtXZ(ObjName+"flat"+i, MyAtX, MyAtZ, rmZMetersToFraction(Width*2),rmZMetersToFraction(Width*2), 3, 1);
//      SetMainLandType(id, 6, SeaLevel+4,GetRoadType());
      SetMainLandType(id, 6, (StartHeight-(Riser * i)-SeaLevel) * .65,GetRoadType());
      rmSetAreaCliffType(id, GetCliffType());
      rmSetAreaCliffEdge(id, 1, 1.0, 0.0, 1.0, 0);
      rmSetAreaCliffPainting(id, true, true, true, 1.5, true);
      rmSetAreaCliffHeight(id, 1, 1.0, 1.0);
   }
   rmBuildAllAreas();

   for (i=0; <=NumSteps) {
      NextPoint = rmZMetersToFraction(i * LineLength/NumSteps);
      MyAtX=GetXPointOnCircle(Angle, NextPoint, StartX);
      MyAtZ=GetZPointOnCircle(Angle, NextPoint, StartZ);
      id = CreateAreaAtXZ(ObjName+"ramp"+i, MyAtX, MyAtZ, rmZMetersToFraction(Width),rmZMetersToFraction(Width), 1, 1);
      SetMainLandType(id, 6, StartHeight-(Riser * i)-SeaLevel+1,GetRoadType());
      rmAddAreaToClass(id, classRamp);
   }
   rmBuildAllAreas();
   return(id);
}

int MakeWaterWay(string ObjName="", float Angle=0, float StartX=.5, float StartZ=.5, int classWaterWay=0) {
   float NextPoint=0;
   float Width=3.5;
   float LineLength=rmZMetersToFraction(Width);
   float NumSteps = 1.0/LineLength;
   for (i=0; <=NumSteps) {
      NextPoint = rmZMetersToFraction(i * Width);
      float MyAtX=GetXPointOnCircle(Angle, NextPoint, StartX);
      float MyAtZ=GetZPointOnCircle(Angle, NextPoint, StartZ);
      int id = CreateAreaAtXZ(ObjName+"waterway"+i, MyAtX, MyAtZ, rmZMetersToFraction(Width),rmZMetersToFraction(Width), 1, 1);
      SetMainWaterType(id);
//      BlobulateArea(id, 3, rmRandInt(5, 10),  rmRandInt(10, 20), rmRandInt(10, 25));
      rmSetAreaBaseHeight(id,SeaLevel);
      rmAddAreaToClass(id, classWaterWay);
   }
   rmBuildAllAreas();
   return(id);
}

void main(void) {
   rmSetStatusText("In The Beginning...",0.05);
/* CONSTANTS ************************************/
   WaterOnMap=rmRandInt(0,1); //%50 Chance of some random water areas
//   WaterOnMap=1;
   int myTiles = iifF(cMapSize==0,10000,15000);
   myTiles=iifF(WaterOnMap==0,myTiles,myTiles*1.2); // 20% bigger on waterway map
   int mySize = 2 * sqrt(cNumberPlayers * myTiles);
   MapSkin = rmRandInt(1,100);  // I don't like hades,so only do it rarely, very.
   if (MapSkin>1) MapSkin = rmRandInt(1,4);
   else MapSkin = 5;
//   MapSkin = 2;
   LandOrSea = rmRandInt(0,1);
   LandOrSea=0;

   float MyAtX=0;
   float MyAtZ=0;
   int id=0;
   rmSetMapSize(mySize,mySize); // METERS
   rmSetSeaLevel(SeaLevel);
   rmSetSeaType(GetWaterType());
   if (LandOrSea==0) rmTerrainInitialize(GetLandType());
   else rmTerrainInitialize("water");

   // Define some classes.
   int classTownCenters=rmDefineClass("TownCenters");
   int classPlayer=rmDefineClass("PlayerAreas");
   int classRamp=rmDefineClass("PlayerRamps");
   int classWaterWay=rmDefineClass("WaterOnEdges");
   int classCliffs=rmDefineClass("CliffsGorges");
   int classLand=rmDefineClass("LandMasses");
   int classForest=rmDefineClass("Forests");
   int classLakes=rmDefineClass("Lakes");
   int classAnimals=rmDefineClass("Animals");

   // Keep Things Off The Map Edges
   int avoidMapEdgesShort=rmCreateBoxConstraint("Avoid Edge Short", rmXTilesToFraction(cShort), rmZTilesToFraction(cShort), 1.0-rmXTilesToFraction(cShort), 1.0-rmZTilesToFraction(cShort));
   int avoidMapEdgesMedium=rmCreateBoxConstraint("Avoid Edge Medium", rmXTilesToFraction(cMedium), rmZTilesToFraction(cMedium), 1.0-rmXTilesToFraction(cMedium), 1.0-rmZTilesToFraction(cMedium));
   int avoidMapEdgesLong=rmCreateBoxConstraint("Avoid Edge Long", rmXTilesToFraction(cLong), rmZTilesToFraction(cLong), 1.0-rmXTilesToFraction(cLong), 1.0-rmZTilesToFraction(cLong));

   // Used For Various Land Masses
   int avoidLandAreaShort=rmCreateClassDistanceConstraint("Avoid Other Land Short", classLand, cShort);
   int avoidLandAreaMedium=rmCreateClassDistanceConstraint("Avoid Other Land Medium", classLand, cMedium);
   int avoidLandAreaLong=rmCreateClassDistanceConstraint("Avoid Other Land Long", classLand, cLong);

   // Used For Various Cliffs/Gorges
   int avoidCliffsGorgesShort=rmCreateClassDistanceConstraint("Avoid CliffsGorges Short", classCliffs, cShort);
   int avoidCliffsGorgesMedium=rmCreateClassDistanceConstraint("Avoid CliffsGorges Medium", classCliffs, cMedium);
   int avoidCliffsGorgesLong=rmCreateClassDistanceConstraint("Avoid CliffsGorges Long", classCliffs, cLong);

   // Animals
   int avoidAnimalsShort=rmCreateClassDistanceConstraint("Avoid Other Animals Short", classAnimals, cShort);
   int avoidAnimalsMedium=rmCreateClassDistanceConstraint("Avoid Other Animals Medium", classAnimals, cMedium);
   int avoidAnimalsLong=rmCreateClassDistanceConstraint("Avoid Other Animals Long", classAnimals, cLong);

   // Player Areas Constraint
   int avoidPlayerAreasVeryShort=rmCreateClassDistanceConstraint("Avoid Players Areas VeryShort", classPlayer, cVeryShort);
   int avoidPlayerAreasShort=rmCreateClassDistanceConstraint("Avoid Players Areas Short", classPlayer, cShort);
   int avoidPlayerAreasMedium=rmCreateClassDistanceConstraint("Avoid Players Areas Medium", classPlayer, cMedium);
   int avoidPlayerAreasLong=rmCreateClassDistanceConstraint("Avoid Players Areas Long", classPlayer, cLong);
   // Player Ramp Constraint
   int avoidPlayerRampShort=rmCreateClassDistanceConstraint("Avoid Players Ramp Short", classRamp, cShort);
   int avoidPlayerRampLong=rmCreateClassDistanceConstraint("Avoid Players Ramp Long", classRamp, cLong);

   // Town Centers constraint.
   int avoidTownCentersShort=rmCreateClassDistanceConstraint("avoid TownCenters Short", classTownCenters, cShort);
   int avoidTownCentersMedium=rmCreateClassDistanceConstraint("avoid TownCenters Medium", classTownCenters, cMedium);
   int avoidTownCentersLong=rmCreateClassDistanceConstraint("avoid TownCenters Long", classTownCenters, cLong);

   // Building constraints - Used For Additoinal Settlements
   int avoidBuildingsShort=rmCreateTypeDistanceConstraint("Avoid Buildings Short", "Building", cShort);
   int avoidBuildingsMedium=rmCreateTypeDistanceConstraint("Avoid Buildings Medium", "Building", cMedium);
   int avoidBuildingsLong=rmCreateTypeDistanceConstraint("Avoid Buildings Long", "Building", cLong);
   int avoidBuildingsVeryLong=rmCreateTypeDistanceConstraint("Avoid Buildings VeryLong", "Building", cVeryLong);

   // Gold
   int avoidGoldLong=rmCreateTypeDistanceConstraint("avoid Gold Long", "gold", cLong);

   // Relics
   int avoidRelicLong=rmCreateTypeDistanceConstraint("avoid Relics Long", "relic", cLong);

   // Avoid impassable land
   int avoidImpassableLandShort=rmCreateTerrainDistanceConstraint("Avoid Impassable Land Short", "land", false, cShort);
   int avoidImpassableLandMedium=rmCreateTerrainDistanceConstraint("Avoid Impassable Land Medium", "land", false, cMedium);
   int avoidImpassableLandLong=rmCreateTerrainDistanceConstraint("Avoid Impassable Land Long", "land", false, cLong);

   // Forests
   int avoidForestShort=rmCreateClassDistanceConstraint("Avoid Forest Short", classForest, cShort);
   int avoidForestMedium=rmCreateClassDistanceConstraint("Avoid Forest Medium", classForest, cMedium);
   int avoidForestLong=rmCreateClassDistanceConstraint("Avoid Forest Long", classForest, cLong);

   // Avoid Water
   int avoidWaterVeryShort=rmCreateTerrainDistanceConstraint("avoid water very short", "land", false, cVeryShort);
   int avoidWaterLong=rmCreateTerrainDistanceConstraint("avoid water Long", "land", false, cLong);

   // Near To Water
   nearShoreLineVeryShort=rmCreateTerrainMaxDistanceConstraint("near shoreline very short", "water", false, 1);
   int nearShoreLineShort=rmCreateTerrainMaxDistanceConstraint("near shoreline short", "water", false, cShort);

   // Avoid All Objects
   int avoidAllVeryShort=rmCreateTypeDistanceConstraint("avoid all", "all", cVeryShort); // Keep stuff off each other


   // -------------Define objects
   // Close Objects
   int TownCenterId=rmCreateObjectDef("TownCenter");
   rmAddObjectDefItem(TownCenterId, "Settlement Level 1", 1, 0.0);
   rmAddObjectDefToClass(TownCenterId, classTownCenters);
   rmSetObjectDefMinDistance(TownCenterId, 0.0);
   rmSetObjectDefMaxDistance(TownCenterId, 0.0);

   int TowerId=rmCreateObjectDef("Tower");
   rmAddObjectDefItem(TowerId, "tower", 1, 0.0);
   rmSetObjectDefMinDistance(TowerId, 0.0);
   rmSetObjectDefMaxDistance(TowerId, 0.0);

 // Relics
   int RelicId=rmCreateObjectDef("relic");
   rmAddObjectDefItem(RelicId, "relic", 1, 0.0);
   rmSetObjectDefMinDistance(RelicId, 130.0);
   rmSetObjectDefMaxDistance(RelicId, 330.0);
   rmAddObjectDefConstraint(RelicId, avoidRelicLong);
   rmAddObjectDefConstraint(RelicId, avoidAllVeryShort);

   // -------------Done defining objects

   rmSetStatusText("TOS spat upon the land...",0.1);

   if (WaterOnMap==1) {
      MakeWaterWay("WaterWay00", 0, 0, 0, classWaterWay);
      MakeWaterWay("WaterWay01", 270, 0, 1, classWaterWay);
      MakeWaterWay("WaterWay10", 90, 1, 0, classWaterWay);
      MakeWaterWay("WaterWay11", 180, 1, 1, classWaterWay);
      for(j=1; <=30) BeautifyWater("WaterWayFish_"+j, classWaterWay, 1, 0, 1);
      for(j=1; <=30) BeautifyWater("WaterWayPlants_"+j, classWaterWay, 0, 1, 1);
   }

   float PlayerAreaSize=rmZMetersToFraction(16.0+WaterOnMap);
   float PlayerAreaHeight=2.0;
   float PlayerAreaRampWidth=1; //.75;
   float MountainEdgeDist = PlayerAreaSize * (2.65+cNumberPlayers+WaterOnMap);

   int StartCorner = rmRandInt(1,4); // PICK A RANDOM START CORNER
   int Corner1=0; // SINCE THIS MAP PLACES PLAYERS
   int Corner2=0; // AT EXACT MAP LOCATIONS
   int Corner3=0; // AT LEAST START PLAYER 1 IN
   int Corner4=0; // A DIFFERENT SPOT EACH TIME
   if (StartCorner==1) {
      Corner1 = 1;
      Corner2 = 2;
      if (cNumberPlayers>3) Corner3 = 3;
      if (cNumberPlayers>4) Corner4 = 4;
   }
   if (StartCorner==2) {
      Corner1 = 2;
      Corner2 = 1;
      if (cNumberPlayers>3) Corner3 = 4;
      if (cNumberPlayers>4) Corner4 = 3;
   }
   if (StartCorner==3) {
      Corner3 = 1;
      Corner4 = 2;
      if (cNumberPlayers>3) Corner1 = 3;
      if (cNumberPlayers>4) Corner2 = 4;
   }
   if (StartCorner==4) {
      Corner3 = 2;
      Corner4 = 1;
      if (cNumberPlayers>3) Corner1 = 4;
      if (cNumberPlayers>4) Corner2 = 3;
   }

   if (Corner1>0) {
      MyAtX=GetXPointOnCircle(225, (MountainEdgeDist), 1); // MOVE IN FROM EDGE TOWARD CENTER
      MyAtZ=GetZPointOnCircle(225, (MountainEdgeDist), 1);
      BuildMountainAtXZ("BuildKeep45", 45, MyAtX, MyAtZ,  PlayerAreaSize, PlayerAreaHeight, 3, Corner1, classPlayer);
      MakeRamp("KeepStep225", 225, 90, 30, MyAtX, MyAtZ, PlayerAreaHeight, PlayerAreaRampWidth, classRamp);
      PlayerStash("Stash11", 1, 1, nearShoreLineVeryShort);
      ObjectsInACircle(TowerId, 180, 270, 90, rmZMetersToFraction(32), MyAtX, MyAtZ, Corner1, 1);
      ObjectsInACircle(TowerId, 215, 235, 20, rmZMetersToFraction(105), MyAtX, MyAtZ, Corner1, 1);
   }
   if (Corner2>0) {
      MyAtX=GetXPointOnCircle(45, (MountainEdgeDist), 0);
      MyAtZ=GetZPointOnCircle(45, (MountainEdgeDist), 0);
      BuildMountainAtXZ("BuildKeep225", 225, MyAtX, MyAtZ,  PlayerAreaSize, PlayerAreaHeight, 3, Corner2, classPlayer);
      MakeRamp("KeepStep45", 45, 90, 30, MyAtX, MyAtZ, PlayerAreaHeight, PlayerAreaRampWidth, classRamp);
      PlayerStash("Stash00", 0, 0, nearShoreLineVeryShort);
      ObjectsInACircle(TowerId, 0, 90, 90, rmZMetersToFraction(32), MyAtX, MyAtZ, Corner2, 1);
      ObjectsInACircle(TowerId, 35, 55, 20, rmZMetersToFraction(105), MyAtX, MyAtZ, Corner2, 1);
   }
   if (Corner3>0) {
      MyAtX=GetXPointOnCircle(135, (MountainEdgeDist), 1);
      MyAtZ=GetZPointOnCircle(135, (MountainEdgeDist), 0);
      BuildMountainAtXZ("BuildKeep315", 315, MyAtX, MyAtZ,  PlayerAreaSize, PlayerAreaHeight, 3, Corner3, classPlayer);
      MakeRamp("KeepStep135", 135, 90, 30, MyAtX, MyAtZ, PlayerAreaHeight, PlayerAreaRampWidth, classRamp);
      PlayerStash("Stash10", 1, 0, nearShoreLineVeryShort);
      ObjectsInACircle(TowerId, 90, 180, 90, rmZMetersToFraction(32), MyAtX, MyAtZ, Corner3, 1);
      ObjectsInACircle(TowerId, 125, 145, 20, rmZMetersToFraction(105), MyAtX, MyAtZ, Corner3, 1);
   }
   if (Corner4>0) {
      MyAtX=GetXPointOnCircle(315, (MountainEdgeDist), 0);
      MyAtZ=GetZPointOnCircle(315, (MountainEdgeDist), 1);
      BuildMountainAtXZ("BuildKeep135", 135, MyAtX, MyAtZ,  PlayerAreaSize, PlayerAreaHeight, 3, Corner4, classPlayer);
      MakeRamp("KeepStep315", 315, 90, 30, MyAtX, MyAtZ, PlayerAreaHeight, PlayerAreaRampWidth, classRamp);
      PlayerStash("Stash01", 0, 1, nearShoreLineVeryShort);
      ObjectsInACircle(TowerId, 270, 360, 90, rmZMetersToFraction(32), MyAtX, MyAtZ, Corner4, 1);
      ObjectsInACircle(TowerId, 305, 325, 20, rmZMetersToFraction(105), MyAtX, MyAtZ, Corner4, 1);
   }
   if (cNumberPlayers>4) {
      rmSetTeamSpacingModifier(.3);
      rmPlacePlayersSquare(0.3, 0.05, 0.05);
   }

   if (rmRandInt(1,2)==1) {
      rmSetStatusText("and created Lakes...",0.15);
      int WaterAreaSize = rmRandInt(10,20);
      WaterArea("Lakes",rmRandInt(4,cNumberPlayers+2),5,WaterAreaSize,WaterAreaSize/5, WaterAreaSize/2, classLakes, avoidMapEdgesShort,avoidPlayerAreasVeryShort);
   }

   int NumCliffs=4;
   if (cMapSize==0) NumCliffs=NumCliffs/2;
   rmSetStatusText("and Mountians...",0.3);
   LandArea("Cliffs",NumCliffs,2,3,2,5,rmRandInt(8,15),classCliffs, avoidImpassableLandLong, avoidPlayerRampLong);
   rmSetStatusText("and Valleys...",0.4);
   LandArea("Gorges",NumCliffs,-2,-2,2,5,rmRandInt(8,15),classCliffs, avoidPlayerAreasShort, avoidImpassableLandMedium, avoidPlayerRampLong);
   rmSetStatusText("and Nooks and Cranies...",0.5);
   LandArea("Hills",NumCliffs*3,0,2,99,5,rmRandInt(5,10), 0, avoidLandAreaMedium, avoidPlayerAreasShort, avoidImpassableLandShort);
   LandArea("Gullys",NumCliffs*3,-2,0,99,5,rmRandInt(5,10), classLand, avoidLandAreaMedium, avoidPlayerAreasShort, avoidImpassableLandShort);
   rmSetStatusText("and Forests...",0.6);
   ForestArea("RunForestRun1",NumCliffs*2,-2,2,3,rmRandInt(3,6), classForest, avoidPlayerAreasMedium, avoidForestMedium, avoidMapEdgesShort, avoidCliffsGorgesMedium);
   ForestArea("RunForestRun2",NumCliffs*2,-2,2,3,rmRandInt(3,6), classForest, avoidPlayerAreasMedium, avoidForestMedium, avoidMapEdgesShort, avoidCliffsGorgesMedium);
   ForestArea("RunForestRun3",NumCliffs*2,-2,2,3,rmRandInt(3,6), classForest, avoidPlayerAreasMedium, avoidForestMedium, avoidMapEdgesShort, avoidCliffsGorgesMedium);

   rmSetStatusText("and some Shacks...",0.7);
   // Town Centers
   rmPlaceObjectDefPerPlayer(TownCenterId, true);
   // Towers.
//   rmPlaceObjectDefPerPlayer(TowerId, true, 2);

   // Expansion Settlements
   int SettlementId=rmCreateObjectDef("far settlement");
   rmAddObjectDefItem(SettlementId, "Settlement", 1, 0.0);
   rmAddObjectDefConstraint(SettlementId, avoidMapEdgesMedium);
   rmAddObjectDefConstraint(SettlementId, avoidPlayerRampShort);
//   rmAddObjectDefConstraint(SettlementId, nearShoreLineShort);
   rmAddObjectDefConstraint(SettlementId, avoidWaterVeryShort);
   rmSetObjectDefMinDistance(SettlementId, 50.0);
   rmSetObjectDefMaxDistance(SettlementId, 75.0);
   rmPlaceObjectDefPerPlayer(SettlementId, false, 1);
//   rmAddObjectDefConstraint(SettlementId, avoidMapEdgesLong);
   rmAddObjectDefConstraint(SettlementId, avoidImpassableLandShort);
   rmAddObjectDefConstraint(SettlementId, avoidBuildingsVeryLong);
   rmSetObjectDefMinDistance(SettlementId, 120.0);
   rmSetObjectDefMaxDistance(SettlementId, 180.0);
   rmPlaceObjectDefPerPlayer(SettlementId, false, 1);

   rmSetStatusText("TOS then got Hungry...",0.8);
   int FoodValue = 400;
   // FOOD UP THE MAP - REAL CLOSE HERD FOOD - HerdHuntFishPred
   for(i=1; <=rmRandInt(1,1)) {
      id = CreateAnimals("closeHerd"+i, 1, FoodValue, 5, 10+(i*3));
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   FoodValue = 200;
   // FOOD UP THE MAP - REAL CLOSE FISHES
   for(i=1; <=rmRandInt(2,4)) {
      id = CreateAnimals("closeFish"+i, 3, FoodValue, 15, 100, classAnimals, avoidAnimalsMedium);
      rmAddObjectDefConstraint(id, nearShoreLineVeryShort);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   FoodValue = 200;
   // FOOD UP THE MAP - NEAR BY HERD FOOD
   for(i=1; <=rmRandInt(1,3)) {
      id = CreateAnimals("nearHerd"+i, 1, FoodValue, rmZFractionToMeters(.2), rmZFractionToMeters(.25), classAnimals, avoidMapEdgesMedium, avoidWaterVeryShort, avoidForestMedium);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   FoodValue = 600;
   // FOOD UP THE MAP - NEAR BY HUNTABLE FOOD
   for(i=1; <=rmRandInt(1,2)) {
      id = CreateAnimals("nearHunt"+i, 2, FoodValue, rmZFractionToMeters(.2), rmZFractionToMeters(.25), classAnimals, avoidWaterVeryShort, avoidAnimalsMedium, avoidForestMedium);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   FoodValue = 600;
   // FOOD UP THE MAP - FAR AWAY HUNTABLE FOOD
   for(i=1; <=rmRandInt(1,2)) {
      id = CreateAnimals("farHunt"+i, 2, FoodValue, rmZFractionToMeters(.25), rmZFractionToMeters(.495), classAnimals, avoidWaterVeryShort, avoidAnimalsMedium, avoidForestMedium);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   FoodValue = 100; // THIS IS THE TOTAL HITPOINTS OF THE PREDATORS
   // FOOD UP THE MAP - NEAR BY PREDATORS
   for(i=1; <=rmRandInt(1,3)) {
      id = CreateAnimals("nearPredator"+i, 4, FoodValue, rmZFractionToMeters(.15), rmZFractionToMeters(.25), classAnimals, avoidWaterVeryShort, avoidBuildingsLong, avoidForestMedium);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   FoodValue = 200; // THIS IS THE TOTAL HITPOINTS OF THE PREDATORS
   // FOOD UP THE MAP - FAR AWAY PREDATORS
   for(i=1; <=rmRandInt(1,3)) {
      id = CreateAnimals("farPredator"+i, 4, FoodValue, rmZFractionToMeters(.25), rmZFractionToMeters(.495), classAnimals, avoidWaterVeryShort, avoidBuildingsLong, avoidForestMedium);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }

   rmSetStatusText("and wanted pretty shiny things...",0.9);
   // GOLD IN THE HILLS
   CreateGold(1500, rmZFractionToMeters(.1), 9000, rmZFractionToMeters(.3), 18000, rmZFractionToMeters(.5), avoidGoldLong, avoidWaterVeryShort, avoidPlayerRampShort, avoidMapEdgesMedium); // 3 Amount & Distances
   // Relics
   rmPlaceObjectDefPerPlayer(RelicId, false, 2);
   // Various Rocks
   AddRocks(15*cNumberPlayers, avoidAllVeryShort, avoidPlayerAreasShort, avoidPlayerRampShort);

   rmSetStatusText("and an Uncaged Bird...",0.95);
   id = rmCreateObjectDef("birdfriend");
   rmAddObjectDefItem(id,GetBirdType(),1,0.0);
   rmPlaceObjectDefPerPlayer(id, false, 2);
   rmSetIgnoreForceToGaia(true);
   rmPlaceObjectDefPerPlayer(id, true);

  // Text
   rmSetStatusText("",1.0);

   int often420 = rmRandInt(2,4) * 15;  // 30-60 sec
   int oftenSpeed = rmRandInt(2,4) * 15;  // 30-60 sec
   often420 = 60;
   oftenSpeed = 180;

   rmCreateTrigger("Egg");
   rmCreateTrigger("MorePlease");
   rmCreateTrigger("NowTheyAreOnSpeed");

   rmSwitchToTrigger(rmTriggerID("Egg"));
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1",1);
   rmAddTriggerEffect("Message");
   rmSetTriggerEffectParam("Text","*** MythMatch RMS v1 by TwentyOneScore@BeerInHand.com **** 420 Resources/42 Favor Per Minute-Heros Go Faster Every 3 Mins");
   for(i=1; <cNumberPlayers){
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID",i);
      rmSetTriggerEffectParam("ResName","Gold");
      rmSetTriggerEffectParamInt("Amount",-500);
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID",i);
      rmSetTriggerEffectParam("ResName","Gold");
      rmSetTriggerEffectParamInt("Amount",420);

      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID",i);
      rmSetTriggerEffectParam("ResName","Food");
      rmSetTriggerEffectParamInt("Amount",-500);
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID",i);
      rmSetTriggerEffectParam("ResName","Food");
      rmSetTriggerEffectParamInt("Amount",420);

      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID",i);
      rmSetTriggerEffectParam("ResName","Wood");
      rmSetTriggerEffectParamInt("Amount",-500);
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID",i);
      rmSetTriggerEffectParam("ResName","Wood");
      rmSetTriggerEffectParamInt("Amount",420);
   }
   rmAddTriggerEffect("Send Chat");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("Message", "The High Gods will grant 420 every " + often420 + " seconds.");
   rmAddTriggerEffect("Send Chat");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("Message", "The High Gods will increase Hero speed and Villager's gather rate every " + oftenSpeed + " seconds.");
   rmAddTriggerEffect("Fire Event");
   rmSetTriggerEffectParamInt("EventID",rmTriggerID("MorePlease"));
   rmAddTriggerEffect("Fire Event");
   rmSetTriggerEffectParamInt("EventID",rmTriggerID("NowTheyAreOnSpeed"));
   rmSetTriggerPriority(4);
   rmSetTriggerActive(true);
   rmSetTriggerRunImmediately(true);
   rmSetTriggerLoop(false);

   rmSwitchToTrigger(rmTriggerID("MorePlease"));
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1",often420);
   rmAddTriggerEffect("Sound Filename");
   rmSetTriggerEffectParam("Sound","meteorsmallhit.wav");
   rmAddTriggerEffect("Send Chat");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("Message", "The High Gods have granted you 420...");
   for(i=1; <= cNumberPlayers){
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID",i);
      rmSetTriggerEffectParam("ResName","Gold");
      rmSetTriggerEffectParamInt("Amount",420);
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID",i);
      rmSetTriggerEffectParam("ResName","Food");
      rmSetTriggerEffectParamInt("Amount",420);
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID",i);
      rmSetTriggerEffectParam("ResName","Wood");
      rmSetTriggerEffectParamInt("Amount",420);
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID",i);
      rmSetTriggerEffectParam("ResName","Favor");
      rmSetTriggerEffectParamInt("Amount",42);
   }
   rmSetTriggerPriority(4);
   rmSetTriggerActive(false);
   rmSetTriggerRunImmediately(false);
   rmSetTriggerLoop(true);

   rmSwitchToTrigger(rmTriggerID("NowTheyAreOnSpeed"));
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1",oftenSpeed);
   rmAddTriggerEffect("Send Chat");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("Message", "The High Gods wish you would move faster!");
   for(i=1; <cNumberPlayers){
      rmAddTriggerEffect("Set Tech Status"); // HEROS GET FASTER BY THE MINUTE
      rmSetTriggerEffectParamInt("PlayerID", i);
      rmSetTriggerEffectParam("TechID", "367"); //Boots of Kick Everything: Heroes are 20% faster
      rmSetTriggerEffectParam("Status", "4");
      rmAddTriggerEffect("Set Tech Status"); // VILLAGERS GATHER FASTER BY THE MINUTE
      rmSetTriggerEffectParamInt("PlayerID", i);
      rmSetTriggerEffectParam("TechID", "296"); //Harmonia's Necklace: Villager gather rate increased by 10%
      rmSetTriggerEffectParam("Status", "4");
   }
   rmSetTriggerPriority(4);
   rmSetTriggerActive(false);
   rmSetTriggerRunImmediately(false);
   rmSetTriggerLoop(true);

}